fr.cnam.tore

## Class Tore

- java.lang.Object
- - fr.cnam.tore.Tore

-     public class Tore
      extends java.lang.Object

  Classe d'implémentation d'un espace rectangulaire orthonormé de Tore

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Tore(int width, int height)` Création d'un espace de Tore défini par sa longueur et sa hauteur

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.awt.Point` | `deplacer(int x, int y, int sensX, int sensY)` Calcule les nouvelles coordonnées d'un point en fonction de son déplacment d'une case dans une des 8 directions.
    `java.awt.Point` | `image(java.awt.Point A, java.awt.Point B)` Cette methode retourne l'image de B par rapporrt a A, c'est a dire le point le plus proche de A dans un espace de tore
    `java.awt.Point` | `lePlusProche(java.awt.Point A, java.util.Vector points, int distanceSeuil)` Cette methode consiste à déterminer le point le plus proche de A dans un espace de Tore parmi un ensemble de points ET dont la distance est superieur à une distance seuil.
    `java.awt.Point` | `sens(java.awt.Point A, java.awt.Point B)` Cette methode retourne le vecteur unitaire du vecteur AB dans un espace normal euclidien orthonorme (ne tient pas compte du tore).
    `java.awt.Point` | `sensTore(java.awt.Point A, java.awt.Point B)` Retourne le sens du vecteur (ou vecteur unitaire) de A vers B dans l'espace de Tore.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Tore

          public Tore(int width,
                      int height)

      Création d'un espace de Tore défini par sa longueur et sa hauteur
      Parameters:
        `width` - longueur (pixel)
        `height` - largeur (pixel)

  - ### Method Detail

    - #### image

          public java.awt.Point image(java.awt.Point A,
                                      java.awt.Point B)

      Cette methode retourne l'image de B par rapporrt a A, c'est a dire le point le plus proche de A dans un espace de tore
      Parameters:
        `A` - : coordonnees du point A
        `B` - : coordonnees du point B
      Returns:
        coordonnees de l'image de B

    - #### sensTore

          public java.awt.Point sensTore(java.awt.Point A,
                                         java.awt.Point B)

      Retourne le sens du vecteur (ou vecteur unitaire) de A vers B dans l'espace de Tore.
      Cela correspond au vecteur de A vers l'image de B.
      Parameters:
        `A` - le point A
        `B` - le point B
      Returns:
        la direction ( (-1,O,+1)(ex: (-1,-1) (1,0), ...)

    - #### lePlusProche

          public java.awt.Point lePlusProche(java.awt.Point A,
                                             java.util.Vector points,
                                             int distanceSeuil)

      Cette methode consiste à déterminer le point le plus proche de A dans un espace de Tore parmi un ensemble de points ET dont la distance est superieur à une distance seuil.
      Parameters:
        `A` - coordonnees du point A
        `points` - Ensemble des points
        `distanceSeuil` - disnance seuil
      Returns:
        le point le plus proche
        si il n'existe pas de tel point alors retourne null. Grace au seuil il ne sera pas pris en consideration. (Sauf si ce seuil est egal a 0).
        Remarque: A peut appartenir à l'ensemble des points.

    - #### sens

          public java.awt.Point sens(java.awt.Point A,
                                     java.awt.Point B)

      Cette methode retourne le vecteur unitaire du vecteur AB dans un espace normal euclidien orthonorme (ne tient pas compte du tore).
      Parameters:
        `A` - le point A
        `B` - le point B
      Returns:
        La valeur de retour est de la forme (+1,+1) , (+1,-1), (+1,0), ....

    - #### deplacer

          public java.awt.Point deplacer(int x,
                                         int y,
                                         int sensX,
                                         int sensY)

      Calcule les nouvelles coordonnées d'un point en fonction de son déplacment d'une case dans une des 8 directions.
      Le calcul tient compte du Tore.
      Parameters:
        `x` - coordonnée en x du point
        `y` - coordonnée en y du point
        `sensX` - direction en X (-1, 0, +1)
        `sensY` - direction en Y (-1, 0, +1)
      Returns:
        les nouvelles coordonnées du point